/**
 * Tencent is pleased to support the open source community by making Tars available.
 *
 * Copyright (C) 2016THL A29 Limited, a Tencent company. All rights reserved.
 *
 * Licensed under the BSD 3-Clause License (the "License"); you may not use this file except 
 * in compliance with the License. You may obtain a copy of the License at
 *
 * https://opensource.org/licenses/BSD-3-Clause
 *
 * Unless required by applicable law or agreed to in writing, software distributed 
 * under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR 
 * CONDITIONS OF ANY KIND, either express or implied. See the License for the 
 * specific language governing permissions and limitations under the License.
 */
#ifndef _TARS2OC_H
#define _TARS2OC_H

#include "parse.h"

#include <cassert>
#include <string>

using namespace tars;

/**
 * tarshmļ
 */
class Tars2OC
{

public:

    /**
     * 
     * @param file
     */
    void createFile(const string &file);


    /**
    * ļĿ¼
    *
    */
    void setBaseDir(const std::string & sPath) { m_sBaseDir = sPath; }


	/**
	 * ǷĬֵ
	 *
	 * @param bCheck
	 */
	void setArc(const bool bArc) { m_bARC = bArc; }
	/**
	 * øԱǷֿռǰ׺
	 */
	void setNeedNS(bool bNeed) { m_bNeedNS = bNeed;}
    /**
	 * ûԶֿռ
	 */
	void setNS(const string& sNS) {m_sNamespace = sNS;}
    //Դ
protected:
	/**
	 * ȡöٻ߽ṹǰ׺ַ
	 * @param sTarsNS  tarsļжֿռ
	 * @param bEnum Ƿö
	 *
	 * @return ǰ׺ַ
	 */
	string getNamePrix(const string& sTarsNS) const;
	
	/**
	 * ȡϹ淶ĳԱ
	 */
	string getPropertyName(const string& sId) const;

    /**
	 *
	 * ȡԶsetter
	 */
	string getSetterName(const string& sId) const;
    /**
     * ĳ͵ַԴ
     * @param pPtr
     *
     * @return string
     */
    string tostr(const TypePtr &pPtr) const;

    /**
     * ڽ͵ַԴ
     * @param pPtr
     *
     * @return string
     */
    string tostrBuiltin(const BuiltinPtr &pPtr) const;
    /**
     * vectorַ
     * @param pPtr
     *
     * @return string
     */
    string tostrVector(const VectorPtr &pPtr) const;

    /**
     * mapַ
     * @param pPtr
     *
     * @return string
     */
    string tostrMap(const MapPtr &pPtr) const;

    /**
     * ĳֽṹķ
     * @param pPtr
     *
     * @return string
     */
    string tostrStruct(const StructPtr &pPtr) const;


    /**
     * ĳöٵķ
     * @param pPtr
     *
     * @return string
     */
    string tostrEnum(const EnumPtr &pPtr) const;

	/**
	 * OBJC 汾2Զ
	 * @param pPtr
	 *
	 * @return string
	 */
	string toTarsV2Procstr(const TypeIdPtr &pPtr) const;

	/**
	 * OBJC汾2ĸϢ
	 * @param pPtr
	 *
	 * @return string
	 */
	string toAddtionalClassName(const TypePtr &pPtr) const;

	/**
	 * ɽṹԵsynthesize
	 * @param vMember
	 *
	 * @return string
	 */
    string writesynthesize(const vector<TypeIdPtr>& vMember) const;

	/**
	 * Initialize
	 * @param pPtr
	 *
	 * @return string
	 */
    string writeInitialize(const StructPtr &pPtr) const;

	/**
	 * ɳʼ庯init
	 * @param vMember
	 *
	 * @return string
	 */
	string writeInit(const vector<TypeIdPtr>& vMember) const;

	/**
	 * 
	 * @param vMember
	 *
	 * @return string
	 */
	string writedealloc(const vector<TypeIdPtr>& vMember) const;

	/**
	 * ɽṹƶ
	 * @param pPtr
	 *
	 * @return string
	 */
	string writeTarsType(const StructPtr &pPtr) const;

	/**
	 * ͱʾ
	 * @param pPtr
	 *
	 * @return string
	 */
    string toClassName(const TypePtr &pPtr) const;
protected:
    /**
	 * ȡtarsжͣrequireoptional
	 * @param pPtr
	 *
	 */
	string getReqOptionType(const TypeIdPtr &pPtr) const;
	/**
	 * жǷretainͣstringͶͶretain
	 * @param pPtr
	 *
	 */
	bool IsRetainType(const TypePtr &pPtr) const;
	/**
	 * ȡṹ͵ıʶƺͣĿǰǽṹö
	 *
	 * @param pPtr
	 * @param namespaceId
	 *
	 * @return
	 */
	map<string,int> getReferences(const StructPtr &pPtr, const string& namespaceId="") const;

	/**
	 * ȡԱͱʶ,
	 * , stHello hello;stHelloΪͱʶ,Ϊṹ
	 *
	 * @param pPtr
	 * @param mRefs
	 */
	void toIncludeName(const TypePtr &pPtr,map<string,int>& mRefs) const;

    /**
     * ɽṹͷļ
     * @param pPtr
     *
     * @return string
     */
    string generateH(const StructPtr &pPtr, const string& namespaceId) const;

    /**
     * ɽṹmļ
     * @param pPtr
     *
     * @return string
     */
    string generateM(const StructPtr &pPtr, const string& namespaceId) const;

    /**
     * öٵmļ
     * @param pPtr
     *
     * @return string
     */
	string generateM(const EnumPtr &pPtr, const string& namespaceId) const;
    /**
     * ͷļԴ
     * @param pPtr
     *
     * @return string
     */
    string generateH(const ContainerPtr &pPtr) const;

    /**
     * öٵͷļԴ
     * @param pPtr
     *
     * @return string
     */
    string generateH(const EnumPtr &pPtr, const string& namespaceId) const;

    /**
     * ֿռͷļʵԴ
     * @param pPtr
     *
     * @return string
     */
    string generate(const NamespacePtr &pPtr) const;

    /**
     * ֿռmļԴ
     * @param pPtr
     *
     * @return string
     */
    string generateM(const NamespacePtr &pPtr) const;

    /**
     * ֿռͷļԴ
     * @param pPtr
     *
     * @return string
     */
    void generate(const ContextPtr &pPtr) const;

    /**
     * ֿռmļԴ
     * @param pPtr
     *
     * @return string
     */
    void generateM(const ContextPtr &pPtr) const;

private:
	enum EM_TYPE
	{
		EM_STRUCT_TYPE = 1,
		EM_ENUM_TYPE = 2
	};
    std::string m_sBaseDir;

    //<modulename,EM_TYPE>, 2:enum,1,stuct;
    mutable map<string,int> m_mIncludes;
	/**
	 * Ƿ֧arc汾
	 *
	 */
	bool m_bARC;
	/**
	 * Ƿֿ֧ռǰ׺
	 */
	bool m_bNeedNS;
	/**
	 *ûԶֿռǰ׺ֵΪգĬȡtarsļжֵ
	 */
	string m_sNamespace;
};

#endif


